library("RMVL")

#
# We find all points which were *not* analyzed by second stage of the pipeline
#


Matlas<-mvl_open("O3a_2_atlas.mvl")

Mskymaps<-Matlas["skymaps", ref=TRUE]

Mstage<-Mskymaps[,"stage", ref=TRUE]
Msnr<-Mskymaps[,"snr", ref=TRUE]
Midx<-Mskymaps[,"idx", ref=TRUE]

N<-dim(Mskymaps)[1]

Mtmp<-mvl_open("full_scan3_tmp.mvl", create=TRUE, append=TRUE)

cat("Creating extent index\n")
mvl_write_extent_index(Mtmp, list(Midx), "extent_index")

Mtmp<-mvl_remap(Mtmp)

indices<-sort(unique(Matlas$parameters[,"idx",recurse=TRUE]))

cat("Finding points\n")
L<-mvl_index_lapply(Mtmp$extent_index, list(indices), function(i, idx) {
	if(i %% 1000 ==0 )cat(".")
	idx_stage1<-idx[Mstage[idx]==1 & Midx[idx]==indices[i]]
	if(length(idx_stage1)<1)return(NULL)
	
	snr_max_idx<-idx_stage1[which.max(Msnr[idx_stage1])]
	
	return(data.frame(snr_threshold=Mskymaps[snr_max_idx, "snr"], ra=Mskymaps[snr_max_idx, "ra"], dec=Mskymaps[snr_max_idx, "dec"], idx=indices[i]))
	
	})
cat("\n")
	
df<-do.call(rbind, L)

df<-merge(df, Matlas$parameters[,], by="idx")

print(df[1:10,])
